## containerd 1.5.2

=== debian/changelog ===
containerd (1.5.2-0ubuntu1~20.10.2) groovy-security; urgency=medium

  * SECURITY UPDATE: unexpected host file permission changes
    - debian/patches/1.5-Cleanup-lchmod-logic-in-archive.patch: cleanup
      lchmod logic in archive in archive/tar.go, archive/tar_freebsd.go,
      archive/tar_mostunix.go, archive/tar_test.go, archive/tar_unix.go,
      archive/tar_windows.go.
    - No CVE number yet

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 13 Jul 2021 12:55:12 -0400

containerd (1.5.2-0ubuntu1~20.10.1) groovy; urgency=medium

  * New upstream release, backport from Impish (LP: #1931464).
  * d/p/skip-tests-with-privilege.patch: add a patch to skip tests which
    require a certain level of privilege not achievable in the build
    environment.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Fri, 21 May 2021 17:02:23 -0300

containerd (1.4.4-0ubuntu1~20.10.1) groovy; urgency=medium

  * Backport version 1.4.4-0ubuntu1 from Hirsute (LP: #1919322).
    - d/control: update Breaks docker.io version to match version in Groovy.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Tue, 16 Mar 2021 18:26:07 -0300
