## containerd 1.5.5~ds1

=== debian/changelog ===
containerd (1.5.5~ds1-1) unstable; urgency=medium

  * Upload to unstable
  * New upstream version 1.5.5~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 23 Aug 2021 23:48:51 +0800

containerd (1.5.4~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.4~ds1
    Fix CVE-2021-32760.

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 20 Jul 2021 02:45:17 +0800

containerd (1.5.3~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.3~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 14 Jul 2021 23:34:39 +0800

containerd (1.5.2~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.2~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 17 Jun 2021 00:28:02 +0800

containerd (1.5.0~rc1~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~rc1~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 14 Apr 2021 00:20:38 +0800

containerd (1.5.0~rc0~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~rc0~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 10 Apr 2021 00:17:58 +0800

containerd (1.5.0~beta4~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta4~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 17 Mar 2021 02:57:58 +0800

containerd (1.5.0~beta3~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta3~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 05 Mar 2021 19:27:36 +0800

containerd (1.5.0~beta2~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta2~ds1
  * Drop github.com/syndtr/gocapability from Depends

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 27 Feb 2021 01:31:44 +0800

containerd (1.5.0~beta1~ds1-2) experimental; urgency=medium

  * Run integration test in autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 06 Feb 2021 19:48:47 +0800

containerd (1.5.0~beta1~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta1~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 06 Feb 2021 17:37:26 +0800

containerd (1.5.0~beta0~ds1-1) experimental; urgency=medium

  * New upstream version 1.5.0~beta0~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 23 Jan 2021 20:42:28 +0800
