=== debian/changelog ===
containerd (1.5.8~ds1-3) unstable; urgency=medium

  * Limit integration test on amd64, arm64, armel, armhf, ppc64el, s390x.
    The image used in integration test is k8s.gcr.io/pause:3.5, which only
    supports these architectures.
  * Add golang-golang-x-time-dev to Build-Depends (Closes: #1002246)

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 22 Dec 2021 01:18:49 +0800

containerd (1.5.8~ds1-2) unstable; urgency=medium

  * Bump golang-github-opencontainers-image-spec-dev to 1.0.2

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 20 Nov 2021 17:26:36 +0800

containerd (1.5.8~ds1-1) unstable; urgency=medium

  * New upstream version 1.5.8~ds1
    + Mitigate CVE-2021-41190

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 20 Nov 2021 02:38:26 +0800

containerd (1.5.7~ds1-2) unstable; urgency=medium

  * Add pkg/cri/annotations to -dev package.

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 09 Nov 2021 00:14:57 +0800

containerd (1.5.7~ds1-1) unstable; urgency=medium

  * New upstream version 1.5.7~ds1
    + CVE-2021-41103: Insufficiently restricted permissions on container
      root and plugin directories
  * Update Standards-Version to 4.6.0 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 05 Oct 2021 18:25:35 +0800
