=== debian/control ===
--- 
+++ 
@@ -42,7 +42,7 @@
                golang-github-klauspost-compress-dev,
                golang-github-moby-locker-dev,
                golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
-               golang-github-opencontainers-image-spec-dev,
+               golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
                golang-github-opencontainers-runc-dev (>= 0.1.0~),
                golang-github-opencontainers-runtime-spec-dev,
                golang-github-opencontainers-selinux-dev,
@@ -56,11 +56,12 @@
                golang-golang-x-net-dev,
                golang-golang-x-sync-dev,
                golang-golang-x-sys-dev,
+               golang-golang-x-time-dev,
                golang-google-grpc-dev,
                golang-gopkg-inf.v0-dev,
                golang-k8s-sigs-structured-merge-diff-dev,
                golang-k8s-sigs-yaml-dev,
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: https://containerd.io/
 Vcs-Git: https://salsa.debian.org/go-team/packages/containerd.git
@@ -115,7 +116,7 @@
          golang-github-klauspost-compress-dev,
          golang-github-moby-locker-dev,
          golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
-         golang-github-opencontainers-image-spec-dev,
+         golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
          golang-github-opencontainers-runc-dev (>= 0.1.0~),
          golang-github-opencontainers-runtime-spec-dev,
          golang-github-opencontainers-selinux-dev,
