=== debian/rules ===
--- 
+++ 
@@ -8,7 +8,8 @@
 EXCLUDES   += cmd/protoc-gen-gogoctrd cmd/containerd-stress
 EXCLUDES   += runtime/v2/example/cmd
 EXCLUDES   += integration
-CRI_FILE   += cmd/containerd/builtins_cri.go pkg/cri
+CRI_FILE   += cmd/containerd/builtins_cri.go
+CRI_FILE   += $(filter-out pkg/cri/annotations,$(wildcard pkg/cri/*))
 CRI_FILE   += vendor/k8s.io
 CRI_FILE   += vendor/github.com/containerd/imgcrypt
 CRI_FILE   += vendor/github.com/containerd/nri
