## containerd 1.5.9

=== integration/images/volume-copy-up/Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.

all: build

PROJ=gcr.io/k8s-cri-containerd
VERSION=2.0
IMAGE=$(PROJ)/volume-copy-up:$(VERSION)
PLATFORMS?=linux/amd64,linux/arm64

configure-docker:
	gcloud auth configure-docker

build:
	docker buildx build \
	$(OUTPUT) \
	--platform=${PLATFORMS} \
	--tag $(IMAGE) .

push: OUTPUT=--push
push: configure-docker build

.PHONY: configure-docker build push
