=== debian/tests/control ===
Tests: basic-smoke
Depends: ca-certificates, @
Restrictions: allow-stderr isolation-machine needs-root
